'use strict';

var react = require('react');

function _taggedTemplateLiteral(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _templateObject7() {
  var data = _taggedTemplateLiteral(["light"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = _taggedTemplateLiteral(["dark"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = _taggedTemplateLiteral(["dark"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteral(["light"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["dark"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["light"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["dark"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var query = function query(_ref) {
  var _ref2 = _slicedToArray(_ref, 1),
      mode = _ref2[0];

  return "(prefers-color-scheme: ".concat(mode, ")");
};

var usePrefersColorScheme = function usePrefersColorScheme() {
  var _useState = react.useState('no-preference'),
      _useState2 = _slicedToArray(_useState, 2),
      preferredColorSchema = _useState2[0],
      setPreferredColorSchema = _useState2[1];

  if (typeof window.matchMedia !== 'function') {
    return preferredColorSchema;
  }

  var isDark = window.matchMedia(query(_templateObject())).matches;
  var isLight = window.matchMedia(query(_templateObject2())).matches;
  react.useEffect(function () {
    if (isDark) setPreferredColorSchema('dark');else if (isLight) setPreferredColorSchema('light');else setPreferredColorSchema('no-preference');
  }, [isDark, isLight]);
  react.useEffect(function () {
    try {
      window.matchMedia(query(_templateObject3())).addEventListener('change', function (_ref3) {
        var matches = _ref3.matches;
        return matches && setPreferredColorSchema('dark');
      });
      window.matchMedia(query(_templateObject4())).addEventListener('change', function (_ref4) {
        var matches = _ref4.matches;
        return matches && setPreferredColorSchema('light');
      });
    } catch (error) {
      window.matchMedia(query(_templateObject5())).addListener(function () {
        return setPreferredColorSchema(isDark ? 'light' : 'dark');
      });
    }

    return function () {
      window.matchMedia(query(_templateObject6())).removeEventListener();
      window.matchMedia(query(_templateObject7())).removeEventListener();
    };
  }, []);
  return preferredColorSchema;
};

module.exports = usePrefersColorScheme;
//# sourceMappingURL=index.js.map
